import sys
import pygame
from pygame.locals import *

import state
import level
import player

class Game(state.State):
    updates = []
    def __init__(self):
        self.display = pygame.display.get_surface()
        self.surface_manager = pygame.sprite.RenderUpdates()
        self.level_manager = state.StateMachine(self, level.Level())
        self.player = player.Player()
        self.background = pygame.image.load("data/images/city.png").convert_alpha()
        self.surface_manager.add(self.player)
        self.timer = pygame.time.Clock()

    def enter(self):
        pass

    def exit(self):
        pass

    def reason(self):
        for event in pygame.event.get():
            if event.type == QUIT:
                pygame.quit()
                sys.exit()

    def act(self):
        self.timer.tick(60)
        self.surface_manager.clear(self.display, self.background)

        keys = pygame.key.get_pressed()
        if keys[K_ESCAPE]:
            pygame.quit()
            sys.exit()
        if keys[K_SPACE]:
            self.player.jump()
        else:
            self.player.stop_jumping()

        self.level_manager.update()
        self.surface_manager.update()
        Game.updates.extend(self.surface_manager.draw(self.display))
        pygame.display.update(Game.updates)
        pygame.event.clear()
        Game.updates = []