import pygame
import random

import state
import game
import platform

class Level(state.State):
    surface_manager = pygame.sprite.RenderUpdates()
    def __init__(self):
        self.display = pygame.display.get_surface()
        self.background = pygame.image.load("data/images/city.png").convert_alpha()
        self.current_platforms = []
        self.num_of_platforms = 4
        self.time_since_last = 0

        self.display.blit(self.background, (0, 0))
        self.enter()

    def enter(self):
        new_platform = platform.Platform("data/images/platform.png", Level.surface_manager)
        Level.surface_manager.add(new_platform)
        self.current_platforms.append(new_platform)

    def exit(self):
        Level.surface_manager.empty()

    def reason(self):
        pass

    def act(self):
        Level.surface_manager.clear(self.display, self.background)

        self.check_platforms()

        if (len(self.current_platforms) < self.num_of_platforms) \
                and ((self.current_platforms[-1].pos_x + self.current_platforms[-1].rect.width) <= (self.display.get_width() - random.randint(100, 600))):
            new_platform = platform.Platform("data/images/platform.png", Level.surface_manager)
            Level.surface_manager.add(new_platform)
            self.current_platforms.append(new_platform)
        
        Level.surface_manager.update()
        game.Game.updates.extend(Level.surface_manager.draw(self.display))

    def check_platforms(self):
        for platform in self.current_platforms:
            if not Level.surface_manager.has(platform):
                self.current_platforms.remove(platform)